import { WrappingError } from "./Utils";
export declare abstract class HttpError extends WrappingError {
    readonly instructions: string;
    constructor(message: string, instructions: string, cause?: Error);
    get name(): string;
    abstract get errorCode(): number;
}
export declare class BadRequestError extends HttpError {
    readonly url: string;
    constructor(message: string, instructions: string, url: string, cause?: Error);
    get errorCode(): number;
}
export declare class ForbiddenHttpError extends BadRequestError {
    constructor(thing: string, url: string, cause?: Error);
    get errorCode(): number;
}
export declare class NotFoundHttpError extends BadRequestError {
    constructor(thing: string, url: string, cause?: Error);
    get errorCode(): number;
}
export declare class ServerError extends HttpError {
    constructor(message: string, cause?: Error);
    get errorCode(): number;
}
export declare class ServiceUnavailableHttpError extends ServerError {
    constructor(message: string, cause?: Error);
    get errorCode(): number;
}
